'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _FormStore = require('./containers/FormStore');

var _FormStore2 = _interopRequireDefault(_FormStore);

var _prepareProps2 = require('./utils/prepareProps');

var _prepareProps3 = _interopRequireDefault(_prepareProps2);

var _getValue = require('./utils/getValue');

var _getValue2 = _interopRequireDefault(_getValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Field = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  _inherits(Field, _Component);

  function Field() {
    _classCallCheck(this, Field);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Field).apply(this, arguments));
  }

  _createClass(Field, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props;
      var id = _props.id;
      var defaultValue = _props.defaultValue;
      var validate = _props.validate;

      this.form = this.context._mobxForm; // eslint-disable-line no-underscore-dangle
      this.form.addField(id);
      this.field = this.form.fields[id];

      if (defaultValue) {
        this.field.value = defaultValue;
        this.field.defaultValue = defaultValue;
      }

      if (validate) {
        this.field.validate = validate;
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var id = this.props.id;

      this.form.removeField(id);
    }
  }, {
    key: 'handleChange',
    value: function handleChange(ev) {
      this.field.value = (0, _getValue2.default)(ev);
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus() {
      this.field.active = true;
      this.field.touched = true;
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      this.field.active = false;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props;
      var component = _props2.component;

      var props = _objectWithoutProperties(_props2, ['component']);

      props.onChange = function (ev) {
        return _this2.handleChange(ev);
      };
      props.onFocus = function (ev) {
        return _this2.handleFocus(ev);
      };
      props.onBlur = function (ev) {
        return _this2.handleBlur(ev);
      };

      var _prepareProps = (0, _prepareProps3.default)(_ramda2.default.merge(props, this.field.props));

      var input = _prepareProps.input;
      var meta = _prepareProps.meta;
      var custom = _prepareProps.custom;


      if (typeof component === 'string') {
        return _react2.default.createElement(component, _ramda2.default.merge(custom, input));
      }

      return _react2.default.createElement(component, _ramda2.default.merge(custom, { input: input, meta: meta }));
    }
  }]);

  return Field;
}(_react.Component), _class2.propTypes = {
  id: _react.PropTypes.string.isRequired,
  component: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.string]).isRequired,
  // ---
  type: _react.PropTypes.string,
  validate: _react.PropTypes.func,
  defaultValue: _react.PropTypes.string
}, _class2.contextTypes = {
  _mobxForm: _react.PropTypes.instanceOf(_FormStore2.default).isRequired
}, _temp)) || _class;

exports.default = Field;